/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package librarymanagementsystem;
import javax.swing.*; 
import java.sql.*;
import java.text.SimpleDateFormat;
import java.time.Instant;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.ZoneId;
import java.util.Date;
/**
 *
 * @author felixfaker
 */
public class adminHome extends javax.swing.JFrame {

    /**
     * Creates new form adminHome
     */
    Connection connect = null;
    public adminHome() {
        initComponents();
        connect=SQLiteJava.dbConnector();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        addlib = new javax.swing.JButton();
        viewbooks = new javax.swing.JButton();
        viewlibrarians = new javax.swing.JButton();
        deletelibrarians = new javax.swing.JButton();
        borrowed = new javax.swing.JButton();
        fines = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jLabel1.setFont(new java.awt.Font("Noto Sans", 0, 24)); // NOI18N
        jLabel1.setText("Admin Home");

        addlib.setText("Add Librarian");
        addlib.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addlibActionPerformed(evt);
            }
        });

        viewbooks.setText("View Books");
        viewbooks.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                viewbooksActionPerformed(evt);
            }
        });

        viewlibrarians.setText("View Librarians");
        viewlibrarians.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                viewlibrariansActionPerformed(evt);
            }
        });

        deletelibrarians.setText("Delete Librarians");
        deletelibrarians.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deletelibrariansActionPerformed(evt);
            }
        });

        borrowed.setText("History");
        borrowed.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                borrowedActionPerformed(evt);
            }
        });

        fines.setText("Set Fines");
        fines.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                finesActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(47, 47, 47)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(addlib)
                            .addComponent(viewbooks, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(deletelibrarians, javax.swing.GroupLayout.PREFERRED_SIZE, 129, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                .addComponent(borrowed)
                                .addGap(31, 31, 31)))
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(viewlibrarians)
                            .addComponent(fines, javax.swing.GroupLayout.PREFERRED_SIZE, 120, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(153, 153, 153)
                        .addComponent(jLabel1)))
                .addContainerGap(46, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jLabel1)
                .addGap(33, 33, 33)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(addlib)
                    .addComponent(viewlibrarians)
                    .addComponent(deletelibrarians))
                .addGap(34, 34, 34)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(viewbooks)
                    .addComponent(borrowed)
                    .addComponent(fines))
                .addGap(0, 81, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void addlibActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addlibActionPerformed
        addLibrarian.open_window();
    }//GEN-LAST:event_addlibActionPerformed

    private void viewlibrariansActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_viewlibrariansActionPerformed
        try{
            String libs = "Librarians: \n \n";
        String query = " select * from login where role=2 ";
        PreparedStatement pst = connect.prepareStatement(query);
        ResultSet rs = pst.executeQuery();
        while (rs.next()) {
            String usr = rs.getString("username");
            libs+=usr+"\n";
          }
        JOptionPane.showMessageDialog(null, new JTextArea(libs));
        }
        catch(Exception e)
        {
            System.out.println(e);
        }
    }//GEN-LAST:event_viewlibrariansActionPerformed

    private void viewbooksActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_viewbooksActionPerformed
        try{
            String libs = "Books: \n \n";
        String query = " select * from books ";
        PreparedStatement pst = connect.prepareStatement(query);
        ResultSet rs = pst.executeQuery();
        while (rs.next()) {
            String name = rs.getString("name");
            libs+=name+"\t";
            String author = rs.getString("author");
            libs+=author+"\t";
            int quantity = rs.getInt("quantity");
            libs+="Qty:"+quantity+"\n";
          }
        JOptionPane.showMessageDialog(null,new JTextArea(libs));
        }
        catch(Exception e)
        {
            System.out.println(e);
        }
    }//GEN-LAST:event_viewbooksActionPerformed

    private void deletelibrariansActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deletelibrariansActionPerformed
        deletelibrarian.open_window();
    }//GEN-LAST:event_deletelibrariansActionPerformed

    private void borrowedActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_borrowedActionPerformed
        try{
            String libs = "History: \n \n";
        String query = " select * from borrow ";
        PreparedStatement pst = connect.prepareStatement(query);
        ResultSet rs = pst.executeQuery();
        while (rs.next()) {
            String name = rs.getString("username");
            libs+=name+"\t";
            String author = rs.getString("book");
            libs+=author+"\t";
            String s =new SimpleDateFormat("yyyy-MM-dd").parse(rs.getString("issue_date")).toString();
            String arr[] = s.split(" ");
            libs+=arr[1]+" "+arr[2]+" "+arr[5]+"\t";
            String s1 = new SimpleDateFormat("yyyy-MM-dd").parse(rs.getString("return_date")).toString();
            String arr1[] = s1.split(" ");
            libs+=arr1[1]+" "+arr1[2]+" "+arr1[5]+"\t"; 
            int fine = rs.getInt("fine");
            libs+=fine+"\t";
            if(rs.getInt("returned")==1)
            {
                libs+="Returned\n";
            }
            else if(rs.getInt("returned")==0)
            {
                libs+="Not Returned\n";
            }
          }
        JOptionPane.showMessageDialog(null,new JTextArea(libs));
        }
        catch(Exception e)
        {
            System.out.println(e);
        }
    }//GEN-LAST:event_borrowedActionPerformed

    private void finesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_finesActionPerformed
        try{
        String query = " select * from borrow ";
        PreparedStatement pst = connect.prepareStatement(query);
        ResultSet rs = pst.executeQuery();
        while (rs.next()) {
            LocalDateTime localDateTime = LocalDateTime.now();
            Date date = Date.from( localDateTime.atZone( ZoneId.systemDefault()).toInstant());
            java.sql.Date sDate = new java.sql.Date(date.getTime());
            if(new SimpleDateFormat("yyyy-MM-dd").parse(rs.getString("return_date")).compareTo(sDate)<0 && rs.getInt("fine")==0 && rs.getInt("returned")!=1)
            {
                String query2 = "update borrow set fine = ? where (username = ? AND book = ?) ";
                PreparedStatement pst2 = connect.prepareStatement(query2);
                pst2.setString(2,rs.getString("username"));
                pst2.setString(3,rs.getString("book"));
                pst2.setInt(1,50);
                pst2.execute();
                pst2.close();
            }
          }
        JOptionPane.showMessageDialog(null,"Fines set");
        }
        catch(Exception e)
        {
            System.out.println(e);
        }
    }//GEN-LAST:event_finesActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void open_window() {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(adminHome.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(adminHome.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(adminHome.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(adminHome.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new adminHome().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addlib;
    private javax.swing.JButton borrowed;
    private javax.swing.JButton deletelibrarians;
    private javax.swing.JButton fines;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JButton viewbooks;
    private javax.swing.JButton viewlibrarians;
    // End of variables declaration//GEN-END:variables

}
